## START: Set by rpmautospec
## (rpmautospec version 0.6.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%global _lto_cflags %{nil}
# https://github.com/pytorch/FBGEMM/blob/v0.7.0/CMakeLists.txt#L87
%global soversion 0.1
%global desc %{expand: \
FBGEMM (Facebook GEneral Matrix Multiplication) is a low-precision, high
performance matrix-matrix multiplications and convolution library for
server-side inference.

The library provides efficient low-precision general matrix multiplication for
small batch sizes and support for accuracy-loss minimizing techniques such as
row-wise quantization and outlier-aware quantization. FBGEMM also exploits
fusion opportunities in order to overcome the unique challenges of matrix
multiplication at lower precision with bandwidth-bound operations.}

Name:		fbgemm
Version:	0.6.0
Release:	%autorelease
Summary:	Facebook General Matrix-Matrix Multiplication

License:	BSD-3-Clause
URL:		https://github.com/pytorch/%{name}
Source0:	%{url}/archive/v%{version}/%{name}-%{version}.tar.gz

Patch0:		fbgemm-fedora.patch

ExclusiveArch:	x86_64

BuildRequires:	cmake
BuildRequires:	gcc-c++
BuildRequires:	asmjit-devel
BuildRequires:	cpuinfo-devel
BuildRequires:	gmock-devel
BuildRequires:	gtest-devel
BuildRequires:	libomp-devel

%description
%{desc}

%package devel
Summary:	Development files for %{name}
Requires:	%{name}%{?_isa} = %{version}-%{release}

%description devel
%{desc}

%prep
%autosetup -p1 -n FBGEMM-%{version}

rm -rf third_party
# library version
sed -i '$a set_target_properties(fbgemm PROPERTIES SOVERSION 1 VERSION %{soversion})' CMakeLists.txt

%build
%cmake \
	-DCMAKE_BUILD_TYPE=Release \
	-DFBGEMM_LIBRARY_TYPE=shared \
	-DFBGEMM_BUILD_BENCHMARKS=OFF \
	-DFBGEMM_BUILD_TESTS=ON \
	-DFBGEMM_BUILD_DOCS=OFF
%cmake_build

%install
%cmake_install

%check
%ctest

%files
%license LICENSE
%doc README.md
%{_libdir}/libfbgemm.so.%{soversion}
%{_libdir}/libfbgemm.so.1

%files devel
%{_includedir}/%{name}
%{_libdir}/cmake/%{name}
%{_libdir}/libfbgemm.so

%changelog
## START: Generated by rpmautospec
* Wed Jul 17 2024 Fedora Release Engineering <releng@fedoraproject.org> - 0.6.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_41_Mass_Rebuild

* Sat Jul 06 2024 Ali Erdinc Koroglu <aekoroglu@linux.intel.com> - 0.6.0-1
- 1st release
## END: Generated by rpmautospec
